# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from laser_line_extraction/LineSegmentList.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import laser_line_extraction.msg
import std_msgs.msg

class LineSegmentList(genpy.Message):
  _md5sum = "15c60e2ccf21433a5067160ec144f8c3"
  _type = "laser_line_extraction/LineSegmentList"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """Header header
LineSegment[] line_segments

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: laser_line_extraction/LineSegment
float32 radius
float32 angle
float32[4] covariance
float32[2] start
float32[2] end
"""
  __slots__ = ['header','line_segments']
  _slot_types = ['std_msgs/Header','laser_line_extraction/LineSegment[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,line_segments

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LineSegmentList, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.line_segments is None:
        self.line_segments = []
    else:
      self.header = std_msgs.msg.Header()
      self.line_segments = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.line_segments)
      buff.write(_struct_I.pack(length))
      for val1 in self.line_segments:
        _x = val1
        buff.write(_get_struct_2f().pack(_x.radius, _x.angle))
        buff.write(_get_struct_4f().pack(*val1.covariance))
        buff.write(_get_struct_2f().pack(*val1.start))
        buff.write(_get_struct_2f().pack(*val1.end))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.line_segments is None:
        self.line_segments = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.line_segments = []
      for i in range(0, length):
        val1 = laser_line_extraction.msg.LineSegment()
        _x = val1
        start = end
        end += 8
        (_x.radius, _x.angle,) = _get_struct_2f().unpack(str[start:end])
        start = end
        end += 16
        val1.covariance = _get_struct_4f().unpack(str[start:end])
        start = end
        end += 8
        val1.start = _get_struct_2f().unpack(str[start:end])
        start = end
        end += 8
        val1.end = _get_struct_2f().unpack(str[start:end])
        self.line_segments.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.line_segments)
      buff.write(_struct_I.pack(length))
      for val1 in self.line_segments:
        _x = val1
        buff.write(_get_struct_2f().pack(_x.radius, _x.angle))
        buff.write(val1.covariance.tostring())
        buff.write(val1.start.tostring())
        buff.write(val1.end.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.line_segments is None:
        self.line_segments = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.line_segments = []
      for i in range(0, length):
        val1 = laser_line_extraction.msg.LineSegment()
        _x = val1
        start = end
        end += 8
        (_x.radius, _x.angle,) = _get_struct_2f().unpack(str[start:end])
        start = end
        end += 16
        val1.covariance = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=4)
        start = end
        end += 8
        val1.start = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=2)
        start = end
        end += 8
        val1.end = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=2)
        self.line_segments.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2f = None
def _get_struct_2f():
    global _struct_2f
    if _struct_2f is None:
        _struct_2f = struct.Struct("<2f")
    return _struct_2f
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_4f = None
def _get_struct_4f():
    global _struct_4f
    if _struct_4f is None:
        _struct_4f = struct.Struct("<4f")
    return _struct_4f
